<?
	require('config.inc.php');
	require('db.inc.php');
	require('tools.inc.php');

	$where = " WHERE status != 'OK' AND status_type = 'HARD' ";

	# timeframe
	if ($_GET['start'] != '' && $_GET['end'] != '')
		$where .= " AND unixts >= '".addslashes($_GET['start'])."' AND unixts < '".addslashes($_GET['end'])."'";

	# host/service
	if ($_GET['field'] == 'service')
		$field = 'service';
	else
		$field = 'host';

	# type
	if ($_GET['type'] == 'hour')
	{
		$query = 'SELECT '.$field.', hour, COUNT(*) AS n FROM '.$db_table.' '.$where.' GROUP BY '.$field.', hour ORDER BY '.$field.', hour';
		$type = 'hour';
		$type_n = 24;
	}
	else if ($_GET['type'] == 'weekday')
	{
		$query = 'SELECT '.$field.', weekday, COUNT(*) AS n FROM '.$db_table.' '.$where.' GROUP BY '.$field.', weekday ORDER BY '.$field.', weekday';
		$type = 'weekday';
		$type_n = 7;
	}
	else if ($_GET['type'] == 'day')
	{
		$query = 'SELECT '.$field.', day, COUNT(*) AS n FROM '.$db_table.' '.$where.' GROUP BY '.$field.', day ORDER BY '.$field.', day';
		$type = 'day';
		$type_n = 31;
	}
	else if ($_GET['type'] == 'month')
	{
		$query = 'SELECT '.$field.', month, COUNT(*) AS n FROM '.$db_table.' '.$where.' GROUP BY '.$field.', month ORDER BY '.$field.', month';
		$type = 'month';
		$type_n = 12;
	}
	else if ($_GET['type'] == 'dayofyear')
	{
		$query = 'SELECT '.$field.', dayofyear, COUNT(*) AS n FROM '.$db_table.' '.$where.' GROUP BY '.$field.', dayofyear ORDER BY '.$field.', dayofyear';
		$type = 'dayofyear';
		$type_n = 366;
	}
	else if ($_GET['type'] == 'min')
	{
		$query = 'SELECT '.$field.', min, COUNT(*) AS n FROM '.$db_table.' '.$where.' GROUP BY '.$field.', min ORDER BY '.$field.', min';
		$type = 'min';
		$type_n = 60;
	}
	else if ($_GET['type'] == 'sec')
	{
		$query = 'SELECT '.$field.', sec, COUNT(*) AS n FROM '.$db_table.' '.$where.' GROUP BY '.$field.', sec ORDER BY '.$field.', sec';
		$type = 'sec';
		$type_n = 60;
	}
	else
	{
		$query = 'SELECT '.$field.', hour, COUNT(*) AS n FROM '.$db_table.' '.$where.' GROUP BY '.$field.', hour ORDER BY '.$field.', hour';
		$type = 'hour';
		$type_n = 24;
	}

	$results = do_query($query);
	$prev_field = '';
	$n_fields=0;
	while($row = fetch_row($results))
	{
		$field_cur = $row[$field];
		if (strcasecmp($field_cur, $prev_field) != 0)
		{
			$fields[$n_fields++] = $field_cur;
			$prev_field = $field_cur;
		}
		$when = $row[$type];
		$data[$field_cur][$when] = $row['n'];
	}
?>
<HTML>
<HEAD>
<LINK REL="stylesheet" MEDIA="screen" TYPE="text/css" HREF="style.css" />
<TITLE>Correlating <? print $field; ?>s</TITLE>
</HEAD>
<BODY>
<TABLE WIDTH="100%" HEIGHT="100%">
<TR VALIGN="TOP" HEIGHT="100%"><TD ALIGN="LEFT">

<H1>Correlating <? print $field; ?></H1>
Hosts are correlated by the number of events per <? print $type; ?>.<BR>
Correlated using the <A HREF="http://en.wikipedia.org/wiki/Pearson_product-moment_correlation_coefficient">pearson correlation coefficient</A>.<BR>
<BR>
Correlate by: <?
function show_by($type)
{
	print "<A HREF=\"correlate_field.php?type=$type&field=$field";
	if ($period_html != '')
	{
		print $period_html;
	}
	print "\">$type</A>";
}
show_by('sec'); print ' - ';
show_by('min'); print ' - ';
show_by('hour'); print ' - ';
show_by('weekday'); print ' - ';
show_by('day'); print ' - ';
show_by('month'); print ' - ';
show_by('dayofyear');
?><BR>
<BR>

<? show_period(); ?>

<H2>Matrix view</H2>
<?
	$max_correlation = -1000.0; # value is always positive
	$min_correlation = 1000.0;  # value is 1 at most
	$avg_correlation = 0;
	$stddev_correlation = 0;
	$n_correlation   = 0;

	print "<TABLE BORDER='1'>\n";
	print '<TR><TD></TD>';
	for($loop=0; $loop<$n_fields; $loop++)
	{
		print '<TD><B><A HREF="stats_per_field.php?set='.enchttp($fields[$loop]).$period_html.'">'.$fields[$loop].'</A></B></TD>';
	}
	print '</TR>';
	for($hi1=0; $hi1<$n_fields; $hi1++)
	{
		print '<TR><TD><B><A HREF="stats_per_field.php?set='.enchttp($fields[$hi1]).$period_html.'">'.$fields[$hi1].'</A></B></TD>';

		for($hi2=0; $hi2<$n_fields; $hi2++)
		{
			if ($hi1 != $hi2)
			{
				# add up all the values
				$sum1 = 0;
				$sum2 = 0;
				for($loop=0; $loop<$type_n; $loop++)
				{
					$sum1 += $data[$fields[$hi1]][$loop];
					$sum2 += $data[$fields[$hi2]][$loop];
				}

				# sum the squares
				$sumsq1 = 0;
				$sumsq2 = 0;
				for($loop=0; $loop<$type_n; $loop++)
				{
					$sumsq1 += pow($data[$fields[$hi1]][$loop], 2.0);
					$sumsq2 += pow($data[$fields[$hi2]][$loop], 2.0);
				}

				# sum up the products
				$psum=0;
				for($loop=0; $loop<$type_n; $loop++)
				{
					$psum += $data[$fields[$hi1]][$loop] * $data[$fields[$hi2]][$loop];
				}

				$num = $psum - ($sum1 * $sum2 / $type_n);
				$den = sqrt(($sumsq1 - pow($sum1, 2.0) / $type_n) * ($sumsq2 - pow($sum2, 2.0) / $type_n));

				if ($den == 0)
					$value = 0;
				else
					$value = $num / $den;

				$value = abs($value); # don't care if it is a negative or positive correlation, as long as it is correlated

				# print
				print "<TD ALIGN=CENTER>$value</TD>";

				if ($fields[$hi1] > $fields[$hi2])
					$name = $fields[$hi1].'|'.$fields[$hi2];
				else
					$name = $fields[$hi2].'|'.$fields[$hi1];

				$values[$name] = $value;

				$min_correlation = min($min_correlation, $value);
				$max_correlation = max($max_correlation, $value);
				$avg_correlation += $value;
				$stddev_correlation += pow($value, 2.0);
				$n_correlation++;  # $n_fields * ($n_fields - 1)
			}
			else
			{
				print '<TD></TD>';
			}
		}

		print "</TR>\n";
	}
	print "</TABLE>\n";
	print "<TABLE>\n";
	print "<TR><TD>minimum:</TD><TD COLSPAN=2>$min_correlation</TD></TR>\n";
	$avg_correlation /= $n_correlation;
	$stddev_correlation = sqrt(($stddev_correlation / $n_correlation) - pow($avg_correlation, 2.0));
	print "<TR><TD>average/stddev:</TD><TD>$avg_correlation</TD><TD>$stddev_correlation</TD></TR>\n";
	print "<TR><TD>maximum:</TD><TD COLSPAN=2>$max_correlation</TD></TR>\n";
	print "</TABLE>\n";
?>
<BR>

<H2>Sorted list by correlation</H2>
<?
	arsort($values);
	print '<TABLE BORDER="1">';
	foreach($values as $key => $val)
	{
		$splitted = str_replace('|', '</TD><TD>', $key);
		print "<TR><TD>$splitted</TD><TD>$val</TD></TR>\n";
	}
	print '</TABLE>';
?>

</TD></TR>
<TR><TD><? require('copyright.inc.php'); ?></TD></TR>
</TABLE>
</BODY>
</HTML>
