<?
	require('config.inc.php');
	require('db.inc.php');
	require('tools.inc.php');

	$where = " WHERE status != 'OK' AND status_type = 'HARD' ";

	# timeframe
	if ($_GET['start'] != '' && $_GET['end'] != '')
		$where .= " AND unixts >= '".addslashes($_GET['start'])."' AND unixts < '".addslashes($_GET['end'])."'";

	# type
	if ($_GET['type'] == 'hour')
		$field = 'hour';
	else if ($_GET['type'] == 'weekday')
		$field = 'weekday';
	else if ($_GET['type'] == 'day')
		$field = 'day';
	else if ($_GET['type'] == 'month')
		$field = 'month';
	else if ($_GET['type'] == 'dayofyear')
		$field = 'dayofyear';
	else if ($_GET['type'] == 'min')
		$field = 'min';
	else if ($_GET['type'] == 'sec')
		$field = 'sec';
	else
		$field = 'hour';
?>
<HTML>
<HEAD>
<LINK REL="stylesheet" MEDIA="screen" TYPE="text/css" HREF="style.css" />
<TITLE>Correlating hosts</TITLE>
</HEAD>
<BODY>
<TABLE WIDTH="100%" HEIGHT="100%">
<TR VALIGN="TOP" HEIGHT="100%"><TD ALIGN="LEFT">

<H1>Correlating hosts+services</H1>
Hosts+services are correlated by the number of events per <? print $field; ?>.<BR>
Correlated using the <A HREF="http://en.wikipedia.org/wiki/Pearson_product-moment_correlation_coefficient">pearson correlation coefficient</A>.<BR>
<BR>
Correlate by: <?
function show_by($type)
{
	print '<A HREF="correlate_host+service.php?type=$type';
	if ($period_html != '')
	{
		print $period_html;
	}
	print "\">$type</A>";
}
show_by('sec'); print ' - ';
show_by('min'); print ' - ';
show_by('hour'); print ' - ';
show_by('weekday'); print ' - ';
show_by('day'); print ' - ';
show_by('month'); print ' - ';
show_by('dayofyear');
?><BR>
<BR>

<?
show_period();

$query = "
	SELECT
		n1.string AS string1,
		n2.string AS string2,
		SUM(n1.count) AS sum1,
		SUM(n2.count) AS sum2,
		SUM(n1.count * n1.count) AS sum1sq,
		SUM(n2.count * n2.count) AS sum2sq,
		SUM(n1.count * n2.count) AS psum, 
		COUNT(*) AS n
	FROM
		(SELECT CONCAT(host, '-', service) AS string, $field AS field, COUNT(*) AS count FROM $db_table $where GROUP BY $field, string) AS n1,
		(SELECT CONCAT(host, '-', service) AS string, $field AS field, COUNT(*) AS count FROM $db_table $where GROUP BY $field, string) AS n2
	WHERE
		n1.field=n2.field
	GROUP BY
		string1, string2
	ORDER BY
		string1, string2";

$results = do_query($query);
while($row = fetch_row($results))
{
        $string1 = $row['string1'];
        $string2 = $row['string2'];

	$sum1    = $row['sum1'];
	$sum2    = $row['sum2'];
	$sum1sq  = $row['sum1sq'];
	$sum2sq  = $row['sum2sq'];
	$psum    = $row['psum'];
	$n       = $row['n'];

	$den = 0;
	if ($n > 0)
	{
		$num = $psum - ($sum1 * $sum2 / $n);
		$den = sqrt(($sum1sq - pow($sum1, 2.0) / $n) * ($sum2sq - pow($sum2, 2.0) / $n));
	}
	if ($den == 0)
	{
		$r = 0;
	}
	else
	{
		$r = $num / $den;
	}

	$r = abs($r); # don't care if it is a negative or positive correlation, as long as it is correlated

	if ($string1 > $string2)
	{
		$val[$string1.'|'.$string2.'|'.$n] = $r;
	}
	else
	{
		$val[$string2.'|'.$string1.'|'.$n] = $r;
	}
}

arsort($val);

print "<TABLE BORDER='1'>\n";
print "<TR><TD><B>host+service 1</B></TD><TD><B>host+service 2</B></TD><TD><B>correlation</B></TD><TD><B>number of<BR>matching $field"."s</B></TD></TR>\n";
foreach ($val as $key => $value)
{
	$fields = explode('|', $key);
	$f0 = $fields[0];
	$f1 = $fields[1];
	$f2 = $fields[2];

	if ($f0 != $f1)
	{
		print "<TR><TD>$f0</TD><TD>$f1</TD><TD>$value</TD><TD>$f2</TD></TR>\n";
	}
}
print "</TABLE>\n";
?>
</TD></TR>
<TR><TD><? require('copyright.inc.php'); ?></TD></TR>
</TABLE>

</BODY>
</HTML>
