<?

/* Some SQL syntax that vary among DBMS */
function db_ts_from_unixtime($unixtime)
{
    global $db_type;

    if  ($db_type == 'mysql') {
        return "from_unixtime($unixtime)";
    } else {
        return "to_timestamp($unixtime)";
    }
}

function db_week_from_ts($ts)
{
    global $db_type;

    if  ($db_type == 'mysql') {
        return "week($ts)";
    } else {
        return "extract(week from $ts)";
    }
}

function db_quarter_from_ts($ts)
{
    global $db_type;

    if  ($db_type == 'mysql') {
        return "quarter($ts)";
    } else {
        return "extract(quarter from $ts)";
    }
}

/* Queries */

function do_query($query)
{
        global $db_hostname, $db_user, $db_pass, $db_db, $db_type;

# print "$query<BR>\n";

        /* Connecting, selecting database */
	if ($db_type == 'mysql')
	{
		$link = mysqli_connect($db_hostname, $db_user, $db_pass) or die('Could not connect to database');
		mysqli_select_db($link, $db_db) or die('Could not select database');

		$result = mysqli_query($link, $query) or die("Query failed: ".mysqli_error($link).": ".$query);

		/* Closing connection */
		mysqli_close($link);
	}
	else
	{
		$link = pg_connect("host=$db_hostname dbname=$db_db user=$db_user password=$db_pass") or die('Could not connect to database');

		$result = pg_query($link, $query) or die("Query failed: ".pg_last_error($link).": ".$query);

		/* Closing connection */
		pg_close($link);
	}

        return $result;
}

function fetch_row($result)
{
	global $db_type;

	if ($db_type == 'mysql')
	{
		return mysqli_fetch_array($result, MYSQLI_ASSOC);
	}
	else
	{
		return pg_fetch_assoc($result);
	}
}

function do_fetch($query)
{
	$results = do_query($query);

	return fetch_row($results);
}

function num_rows($result)
{
	global $db_type;

	if ($db_type == 'mysql')
	{
		return mysqli_num_rows($result);
	}
	else
	{
		return pg_num_rows($result);
	}
}
?>
